commit:     7c925b49c0ac1bb08fb4e3f7666a571b9e076343
Author:     Michael Orlitzky <mjo <AT> gentoo <DOT> org>
AuthorDate: Tue Oct 31 14:12:47 2017 +0000
Commit:     Michael Orlitzky <mjo <AT> gentoo <DOT> org>
CommitDate: Wed Nov  1 18:54:56 2017 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=7c925b49

mail-filter/spamassassin: new revision to fix the build with openssl-1.1.

This new revision adds a patch (thanks to Mark Wright) that fixes the
build with the new openssl-1.1 branch. Our patch is based on the fix
contributed upstream by Noah Meyerhans (thanks Noah) in SA bug 7361.

In an unrelated change, the SRC_URI was updated to use the https
protocol.

Bug: https://bz.apache.org/SpamAssassin/show_bug.cgi?id=7361
Closes: https://bugs.gentoo.org/624858
Package-Manager: Portage-2.3.8, Repoman-2.3.3

 .../files/spamassassin-3.4.1-bug_7361.patch        | 491 +++++++++++++++++++++
 .../spamassassin/spamassassin-3.4.1-r17.ebuild     | 244 ++++++++++
 2 files changed, 735 insertions(+)

diff --git a/mail-filter/spamassassin/files/spamassassin-3.4.1-bug_7361.patch 
b/mail-filter/spamassassin/files/spamassassin-3.4.1-bug_7361.patch
new file mode 100644
index 00000000000..525bf75c7fe
--- /dev/null
+++ b/mail-filter/spamassassin/files/spamassassin-3.4.1-bug_7361.patch
@@ -0,0 +1,491 @@
+This patch is a modified combination of the patches posted to
+
+  https://bz.apache.org/SpamAssassin/show_bug.cgi?id=7361
+
+that allow SpamAssassin to build against (and work with) openssl-1.1.x.
+Mark Wright (gienah) made the necessary updates to get the patches to
+work on Gentoo and solve bug 624858.
+
+SpamAssassin-bug: 7361
+Gentoo-bug: 624858
+
+--- a/spamc/configure  (revision 1767127)
++++ b/spamc/configure  (working copy)
+@@ -943,7 +943,7 @@ 
+     else
+       echo "$as_me: WARNING: no configuration information is in $ac_dir" >&2
+     fi
+-    cd "$ac_popdir"
++    cd $ac_popdir
+   done
+ fi
+ 
+@@ -1874,7 +1874,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -1932,7 +1933,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -2048,7 +2050,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -2102,7 +2105,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -2147,7 +2151,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -2191,7 +2196,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -2523,7 +2529,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -2693,7 +2700,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -2764,7 +2772,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -2917,7 +2926,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -3069,7 +3079,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -3260,7 +3271,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -3323,7 +3335,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -3388,7 +3401,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -3491,7 +3505,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -3557,7 +3572,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -3628,7 +3644,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -3666,9 +3683,9 @@ 
+ SSLLIBS=""
+ SSLCFLAGS=""
+ if test yes = "$sa_ssl_enabled"; then
+-      echo "$as_me:$LINENO: checking for CRYPTO_lock in -lcrypto" >&5
+-echo $ECHO_N "checking for CRYPTO_lock in -lcrypto... $ECHO_C" >&6
+-if test "${ac_cv_lib_crypto_CRYPTO_lock+set}" = set; then
++      echo "$as_me:$LINENO: checking for CRYPTO_malloc in -lcrypto" >&5
++echo $ECHO_N "checking for CRYPTO_malloc in -lcrypto... $ECHO_C" >&6
++if test "${ac_cv_lib_crypto_CRYPTO_malloc+set}" = set; then
+   echo $ECHO_N "(cached) $ECHO_C" >&6
+ else
+   ac_check_lib_save_LIBS=$LIBS
+@@ -3686,11 +3703,11 @@ 
+ #endif
+ /* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+-char CRYPTO_lock ();
++char CRYPTO_malloc ();
+ int
+ main ()
+ {
+-CRYPTO_lock ();
++CRYPTO_malloc ();
+   ;
+   return 0;
+ }
+@@ -3704,7 +3721,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -3716,20 +3734,20 @@ 
+   ac_status=$?
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); }; }; then
+-  ac_cv_lib_crypto_CRYPTO_lock=yes
++  ac_cv_lib_crypto_CRYPTO_malloc=yes
+ else
+   echo "$as_me: failed program was:" >&5
+ sed 's/^/| /' conftest.$ac_ext >&5
+ 
+-ac_cv_lib_crypto_CRYPTO_lock=no
++ac_cv_lib_crypto_CRYPTO_malloc=no
+ fi
+ rm -f conftest.err conftest.$ac_objext \
+       conftest$ac_exeext conftest.$ac_ext
+ LIBS=$ac_check_lib_save_LIBS
+ fi
+-echo "$as_me:$LINENO: result: $ac_cv_lib_crypto_CRYPTO_lock" >&5
+-echo "${ECHO_T}$ac_cv_lib_crypto_CRYPTO_lock" >&6
+-if test $ac_cv_lib_crypto_CRYPTO_lock = yes; then
++echo "$as_me:$LINENO: result: $ac_cv_lib_crypto_CRYPTO_malloc" >&5
++echo "${ECHO_T}$ac_cv_lib_crypto_CRYPTO_malloc" >&6
++if test $ac_cv_lib_crypto_CRYPTO_malloc = yes; then
+   SSLLIBS="-lcrypto $SSLLIBS"
+ fi
+ 
+@@ -3771,7 +3789,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -3804,7 +3823,7 @@ 
+       # before defining SPAMC_SSL check that all its requirements are
+       # actually available
+       if test yes = "$ac_cv_header_openssl_crypto_h" && \
+-         test yes = "$ac_cv_lib_crypto_CRYPTO_lock" && \
++         test yes = "$ac_cv_lib_crypto_CRYPTO_malloc" && \
+          test yes = "$ac_cv_lib_ssl_SSL_CTX_free"; then
+               SSLCFLAGS="-DSPAMC_SSL"
+       else
+@@ -3854,7 +3873,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -3927,7 +3947,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -4000,7 +4021,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -4073,7 +4095,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -4182,7 +4205,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -4246,7 +4270,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -4311,7 +4336,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -4368,7 +4394,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -4435,7 +4462,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -4500,7 +4528,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -4564,7 +4593,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -4628,7 +4658,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -4692,7 +4723,8 @@ 
+   cat conftest.err >&5
+   echo "$as_me:$LINENO: \$? = $ac_status" >&5
+   (exit $ac_status); } &&
+-       { ac_try='test -z "$ac_c_werror_flag"                   || test ! -s 
conftest.err'
++       { ac_try='test -z "$ac_c_werror_flag"
++                       || test ! -s conftest.err'
+   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+   (eval $ac_try) 2>&5
+   ac_status=$?
+@@ -5527,6 +5559,11 @@ 
+ 
+ 
+ 
++  if test x"$ac_file" != x-; then
++    { echo "$as_me:$LINENO: creating $ac_file" >&5
++echo "$as_me: creating $ac_file" >&6;}
++    rm -f "$ac_file"
++  fi
+   # Let's still pretend it is `configure' which instantiates (i.e., don't
+   # use $as_me), people would be surprised to read:
+   #    /* config.h.  Generated by config.status.  */
+@@ -5565,12 +5602,6 @@ 
+        fi;;
+       esac
+     done` || { (exit 1); exit 1; }
+-
+-  if test x"$ac_file" != x-; then
+-    { echo "$as_me:$LINENO: creating $ac_file" >&5
+-echo "$as_me: creating $ac_file" >&6;}
+-    rm -f "$ac_file"
+-  fi
+ _ACEOF
+ cat >>$CONFIG_STATUS <<_ACEOF
+   sed "$ac_vpsub
+
+--- a/spamc/configure.in       (revision 1767127)
++++ b/spamc/configure.in       (working copy)
+@@ -64,13 +64,13 @@ 
+ SSLLIBS=""
+ SSLCFLAGS=""
+ if test yes = "$sa_ssl_enabled"; then
+-      AC_CHECK_LIB(crypto, CRYPTO_lock,[SSLLIBS="-lcrypto $SSLLIBS"])
++      AC_CHECK_LIB(crypto, CRYPTO_malloc,[SSLLIBS="-lcrypto $SSLLIBS"])
+       AC_CHECK_LIB(ssl, SSL_CTX_free,[SSLLIBS="-lssl $SSLLIBS"],,-lcrypto)
+ 
+       # before defining SPAMC_SSL check that all its requirements are
+       # actually available
+       if test yes = "$ac_cv_header_openssl_crypto_h" && \
+-         test yes = "$ac_cv_lib_crypto_CRYPTO_lock" && \
++         test yes = "$ac_cv_lib_crypto_CRYPTO_malloc" && \
+          test yes = "$ac_cv_lib_ssl_SSL_CTX_free"; then
+               SSLCFLAGS="-DSPAMC_SSL"
+       else
+
+--- a/spamc/libspamc.c 2017-10-20 13:33:54.129653171 +1100
++++ b/spamc/libspamc.c 2017-10-20 13:36:09.429653849 +1100
+@@ -1212,10 +1212,21 @@
+ 
+     if (flags & SPAMC_USE_SSL) {
+ #ifdef SPAMC_SSL
++#if OPENSSL_API_COMPAT >= 0x10100000L
++      OPENSSL_init_ssl(0, NULL);
++      meth = TLS_method();
++      ctx = SSL_CTX_new(meth);
++      if (flags & SPAMC_TLSV1) {
++          SSL_CTX_set_min_proto_version(ctx, TLS1_VERSION);
++      } else {
++          SSL_CTX_set_min_proto_version(ctx, SSL3_VERSION);
++      }
++#else
+       SSLeay_add_ssl_algorithms();
+       meth = SSLv23_client_method();
+       SSL_load_error_strings();
+       ctx = SSL_CTX_new(meth);
++#endif
+ #else
+       UNUSED_VARIABLE(ssl);
+       UNUSED_VARIABLE(meth);
+@@ -1599,10 +1610,17 @@
+ 
+     if (flags & SPAMC_USE_SSL) {
+ #ifdef SPAMC_SSL
++#if OPENSSL_API_COMPAT >= 0x10100000L
++      OPENSSL_init_ssl(0, NULL);
++      meth = TLS_method();
++      ctx = SSL_CTX_new(meth);
++      SSL_CTX_set_min_proto_version(ctx, SSL3_VERSION);
++#else
+       SSLeay_add_ssl_algorithms();
+       meth = SSLv23_client_method();
+       SSL_load_error_strings();
+       ctx = SSL_CTX_new(meth);
++#endif
+ #else
+       UNUSED_VARIABLE(ssl);
+       UNUSED_VARIABLE(meth);

diff --git a/mail-filter/spamassassin/spamassassin-3.4.1-r17.ebuild 
b/mail-filter/spamassassin/spamassassin-3.4.1-r17.ebuild
new file mode 100644
index 00000000000..ba402950811
--- /dev/null
+++ b/mail-filter/spamassassin/spamassassin-3.4.1-r17.ebuild
@@ -0,0 +1,244 @@
+# Copyright 1999-2017 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+inherit perl-functions systemd toolchain-funcs user
+
+MY_P="Mail-SpamAssassin-${PV//_/-}"
+S="${WORKDIR}/${MY_P}"
+DESCRIPTION="An extensible mail filter which can identify and tag spam"
+HOMEPAGE="https://spamassassin.apache.org/";
+SRC_URI="mirror://apache/spamassassin/source/${MY_P}.tar.bz2"
+
+LICENSE="Apache-2.0 GPL-2"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 
~x86-fbsd ~amd64-linux ~x86-linux ~x86-macos"
+IUSE="berkdb cron ipv6 ldap libressl mysql postgres qmail sqlite ssl test"
+
+# The Makefile.PL script checks for dependencies, but only fails if a
+# required (i.e. not optional) dependency is missing. We therefore
+# require most of the optional modules only at runtime.
+REQDEPEND="dev-lang/perl:=
+       dev-perl/HTML-Parser
+       dev-perl/Net-DNS
+       dev-perl/NetAddr-IP
+       virtual/perl-Archive-Tar
+       virtual/perl-Digest-SHA
+       virtual/perl-IO-Zlib
+       virtual/perl-Time-HiRes
+       ssl? (
+               !libressl? ( dev-libs/openssl:0 )
+               libressl? ( dev-libs/libressl )
+       )"
+
+# SpamAssassin doesn't use libwww-perl except as a fallback for when
+# curl/wget are missing, so we depend on one of those instead. Some
+# mirrors use https, so we need those utilities to support SSL.
+#
+# re2c is needed to compile the rules (sa-compile).
+#
+# We still need the old Digest-SHA1 because razor2 has not been ported
+# to Digest-SHA.
+OPTDEPEND="app-crypt/gnupg
+       dev-perl/Digest-SHA1
+       dev-perl/Encode-Detect
+       dev-perl/Geo-IP
+       dev-perl/HTTP-Date
+       dev-perl/Mail-DKIM
+       dev-perl/Mail-SPF
+       dev-perl/Net-Patricia
+       dev-perl/Net-CIDR-Lite
+       dev-util/re2c
+       || ( net-misc/wget[ssl] net-misc/curl[ssl] )
+       virtual/perl-MIME-Base64
+       virtual/perl-Pod-Parser
+       berkdb? ( virtual/perl-DB_File )
+       ipv6? ( dev-perl/IO-Socket-INET6 )
+       ldap? ( dev-perl/perl-ldap )
+       mysql? (
+               dev-perl/DBI
+               dev-perl/DBD-mysql
+       )
+       postgres? (
+               dev-perl/DBI
+               dev-perl/DBD-Pg
+       )
+       sqlite? (
+               dev-perl/DBI
+               dev-perl/DBD-SQLite
+       )
+       ssl? ( dev-perl/IO-Socket-SSL )"
+
+DEPEND="${REQDEPEND}
+       test? (
+               ${OPTDEPEND}
+               virtual/perl-Test-Harness
+       )"
+RDEPEND="${REQDEPEND} ${OPTDEPEND}"
+
+PATCHES=(
+       "${FILESDIR}/spamassassin-3.4.1-bug_7199.patch"
+       "${FILESDIR}/spamassassin-3.4.1-bug_7223.patch"
+       "${FILESDIR}/spamassassin-3.4.1-bug_7231.patch"
+       "${FILESDIR}/spamassassin-3.4.1-bug_7265.patch"
+       "${FILESDIR}/spamassassin-3.4.1-bug_7231-extra.patch"
+       "${FILESDIR}/spamassassin-3.4.1-bug_7404.patch"
+       "${FILESDIR}/spamassassin-3.4.1-bug_7462.patch"
+       "${FILESDIR}/spamassassin-3.4.1-perl526.patch"
+       "${FILESDIR}/spamassassin-3.4.1-bug_7361.patch"
+)
+
+src_prepare() {
+       default
+
+       # The sa_compile test does some weird stuff like hopping around in
+       # the directory tree and calling "make" to create a dist tarball
+       # from ${S}. It fails, and is more trouble than it's worth...
+       perl_rm_files t/sa_compile.t || die 'failed to remove sa_compile test'
+
+       # The spamc tests (which need the networked spamd daemon) fail for
+       # irrelevant reasons. It's too hard to disable them (unlike the
+       # spamd tests themselves -- see src_test), so use a crude
+       # workaround.
+       perl_rm_files t/spamc_*.t || die 'failed to remove spamc tests'
+}
+
+src_configure() {
+       # This is how and where the perl-module eclass disables the
+       # MakeMaker interactive prompt.
+       export PERL_MM_USE_DEFAULT=1
+
+       # Set SYSCONFDIR explicitly so we can't get bitten by bug 48205 again
+       # (just to be sure, nobody knows how it could happen in the first 
place).
+       #
+       # We also set the path to the perl executable explictly. This will be
+       # used to create the initial shebang line in the scripts (bug 62276).
+       perl Makefile.PL \
+               PREFIX="${EPREFIX}/usr" \
+               INSTALLDIRS=vendor \
+               SYSCONFDIR="${EPREFIX}/etc" \
+               DATADIR="${EPREFIX}/usr/share/spamassassin" \
+               PERL_BIN="${EPREFIX}/usr/bin/perl" \
+               ENABLE_SSL="$(usex ssl)" \
+               DESTDIR="${D}" \
+               || die 'failed to create a Makefile using Makefile.PL'
+
+       # Now configure spamc.
+       emake CC="$(tc-getCC)" LDFLAGS="${LDFLAGS}" spamc/Makefile
+}
+
+src_compile() {
+       emake
+       use qmail && emake spamc/qmail-spamc
+}
+
+src_install () {
+       emake install
+       einstalldocs
+
+       # Create the stub dir used by sa-update and friends
+       keepdir /var/lib/spamassassin
+
+       # Move spamd to sbin where it belongs.
+       dodir /usr/sbin
+       mv "${ED}"/usr/bin/spamd "${ED}"/usr/sbin/spamd  || die "move spamd 
failed"
+
+       if use qmail; then
+               dobin spamc/qmail-spamc
+       fi
+
+       ln -s mail/spamassassin "${ED}"/etc/spamassassin || die
+
+       # Disable plugin by default
+       sed -i -e 's/^loadplugin/\#loadplugin/g' \
+               "${ED}/etc/mail/spamassassin/init.pre" \
+               || die "failed to disable plugins by default"
+
+       # Add the init and config scripts.
+       newinitd "${FILESDIR}/3.4.1-spamd.init-r1" spamd
+       newconfd "${FILESDIR}/3.4.1-spamd.conf" spamd
+
+       systemd_newunit "${FILESDIR}/${PN}.service-r3" "${PN}.service"
+       systemd_install_serviced "${FILESDIR}/${PN}.service.conf-r1" \
+                                                        "${PN}.service"
+
+       use postgres && dodoc sql/*_pg.sql
+       use mysql && dodoc sql/*_mysql.sql
+
+       dodoc NOTICE TRADEMARK CREDITS UPGRADE USAGE sql/README.bayes \
+               sql/README.awl procmailrc.example sample-nonspam.txt \
+               sample-spam.txt spamd/PROTOCOL spamd/README.vpopmail \
+               spamd-apache2/README.apache
+
+       # Rename some files so that they don't clash with others.
+       newdoc spamd/README README.spamd
+       newdoc sql/README README.sql
+       newdoc ldap/README README.ldap
+
+       if use qmail; then
+               dodoc spamc/README.qmail
+       fi
+
+       insinto /etc/mail/spamassassin/
+       insopts -m0400
+       newins "${FILESDIR}"/secrets.cf secrets.cf.example
+
+       # Create the directory where sa-update stores its GPG key (if you
+       # choose to import one). If this directory does not exist, the
+       # import will fail. This is bug 396307. We expect that the import
+       # will be performed as root, and making the directory accessible
+       # only to root prevents a warning on the command-line.
+       diropts -m0700
+       dodir /etc/mail/spamassassin/sa-update-keys
+
+       if use cron; then
+               # Install the cron job if they want it.
+               exeinto /etc/cron.daily
+               newexe "${FILESDIR}/update-spamassassin-rules.cron" \
+                          update-spamassassin-rules
+       fi
+
+       # Remove perllocal.pod to avoid file collisions (bug #603338).
+       perl_delete_localpod || die "failed to remove perllocal.pod"
+
+       # The perl-module eclass calls three other functions to clean
+       # up in src_install. The first fixes references to ${D} in the
+       # packlist, and is useful to us, too. The other two functions,
+       # perl_delete_emptybsdir and perl_remove_temppath, don't seem
+       # to be needed: there are no empty directories, *.bs files, or
+       # ${D} paths remaining in our installed image.
+       perl_fix_packlist || die "failed to fix paths in packlist"
+}
+
+src_test() {
+       # Trick the test suite into skipping the spamd tests. Setting
+       # SPAMD_HOST to a non-localhost value causes SKIP_SPAMD_TESTS to be
+       # set in SATest.pm.
+       export SPAMD_HOST=disabled
+       default
+}
+
+pkg_preinst() {
+       # The spamd daemon runs as this user. Use a real home directory so
+       # that it can hold SA configuration.
+       enewuser spamd -1 -1 /home/spamd
+}
+
+pkg_postinst() {
+       elog
+       elog 'No rules are installed by default. You will need to run sa-update'
+       elog 'at least once, and most likely configure SpamAssassin before it'
+       elog 'will work.'
+
+       if ! use cron; then
+               elog
+               elog 'You should consider a cron job for sa-update. One is 
provided'
+               elog 'for daily updates if you enable the "cron" USE flag.'
+       fi
+       elog
+       elog 'Configuration and update help can be found on the wiki:'
+       elog
+       elog '  https://wiki.gentoo.org/wiki/SpamAssassin'
+       elog
+}

Reply via email to